#import "igSalesmanItem.h"

static NSArray* _firstNames, *_lastNames, *_countries;

@implementation igSalesmanItem

+(NSArray*)firstNames
{
    if(_firstNames == nil)
    {
        _firstNames = @[@"Steve", @"Darrell", @"John", @"Bill", @"Jim", @"Max", @"Torrey", @"AJ", @"Ron", @"Ken", @"Tom", @"Jason", @"Dean", @"Tim", @"Chris"];
    }
    
    return _firstNames;
}

+(NSArray*)lastNames
{
    if(_lastNames == nil)
    {
        _lastNames = @[@"Smith", @"Doe", @"Parker", @"Kent", @"Stark", @"Carter", @"Jameson", @"Bower", @"Bond"];
    }
    
    return _lastNames;
}

+(NSArray*)counties
{
    if(_countries == nil)
    {
        _countries = @[@"United States", @"Japan", @"Bulgaria", @"Uruguay", @"Brazil", @"Canada", @"India", @"Austrailia", @"England", @"France", @"Germany", @"Italy", @"Ireland", @"Russia", @"Poland", @"Syria", @"South Africa", @"Nigeria", @"Chile", @"Argentina", @"Ghana"];
    }
    
    return _countries;
}

+(NSString*)getRandomValue:(NSArray*)array
{
    NSInteger num = arc4random_uniform((int)array.count);
    return array[num];
}

+(NSArray*)generateData:(int)count
{
    NSMutableArray* data = [[NSMutableArray alloc]initWithCapacity:count];
    for(int i = 0; i < count; i++)
    {
        igSalesmanItem* item = [[igSalesmanItem alloc]init];
        item.firstName = [NSString stringWithFormat:@"%@ %@", [self getRandomValue:[self firstNames]], [self getRandomValue:[self lastNames]]];
        item.lastName = [self getRandomValue:[self lastNames]];
        item.country = [self getRandomValue:[self counties]];
        double value = arc4random_uniform(10000);
        if (value <= 0)
            value = 5 + arc4random_uniform(10000);
        item.sales = value;
        [data addObject:item];
    }

    
    return data;
}

@end
